﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Text;
using System.Windows.Forms;

namespace AllNotes
{
    public partial class Пароль : Form
    {
        string confrim, stroka, file;
        public Пароль(string confrim, string stroka, string file)
        {
            this.confrim = confrim;
            this.stroka = stroka;
            this.file = file;
            InitializeComponent();
        }

        private void Пароль_Load(object sender, EventArgs e)
        {
            label1.Text = confrim;
            button1.Text = "Подтвердить";
        }

        private void textBox1_KeyUp(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter) button1.PerformClick();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (textBox1.Text != "")
            {
                string FinalValue = Program.Encrypt(stroka, Program.pass1, Program.pass2, Program.metod, Program.pass_interation, Program.initial_vector, Program.keySize);
                using (StreamWriter writer = File.CreateText(file + ".rtf"))
                {
                    writer.WriteLine(FinalValue);
                    writer.Close();

                }
                using (StreamWriter writer = File.CreateText(file + ".cfg"))
                {
                    writer.WriteLine(textBox1.Text);

                    if (Program.date != "" && Program.time_h != "" && Program.time_m != "")
                    {
                        writer.WriteLine(Program.date);
                        writer.WriteLine(Program.time_h);
                        writer.WriteLine(Program.time_m);

                    }
                    writer.Close();
                }
                this.Close();
            }
            else
            {
                StreamReader cfg1 = new StreamReader(file + ".cfg");
                string password1 = cfg1.ReadLine();

                string date = cfg1.ReadLine();
                cfg1.Close();
                using (StreamWriter writer = File.CreateText(file + ".cfg"))
                {
                    writer.WriteLine(cfg1);

                    if (Program.date != "" && Program.time_h != "" && Program.time_m != "")
                    {
                        writer.WriteLine(Program.date);
                        writer.WriteLine(Program.time_h);
                        writer.WriteLine(Program.time_m);

                    }
                    writer.Close();

                }
            } 
            this.Close();
            
            Program.Pass.pass_in = true;
        }
    }
}
