﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.IO;
using System.Security.Cryptography;
using System.Text;
using System.Web;
using System.Windows.Forms;
using static System.Net.Mime.MediaTypeNames;
using static System.Windows.Forms.VisualStyles.VisualStyleElement;

namespace AllNotes
{
    public partial class Form1 : Form
    {
        string patha = System.IO.Path.Combine(System.Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments), "AllNotes");
        string mydoc = System.Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments);
        string pad = @"Allnotes";
        string[] okonch = { "дней", "день", "дня", "дня", "дня", "дней", "дней", "дней", "дней", "дней", "дней", "дней", "дней", "дней", "дней", };

        public Form1()
        {
            InitializeComponent();
            this.listBox1.DrawMode = DrawMode.OwnerDrawFixed;
            this.listBox1.DrawItem += new System.Windows.Forms.DrawItemEventHandler(listBox1_DrawItem);
            this.listBox1.SelectedIndexChanged += new System.EventHandler(listBox1_SelectedIndexChanged);
        }

        private void Form1_Load_1(object sender, EventArgs e)
        {


            textBox1.SelectionStart = 0;

            listBox1.BackColor = this.BackColor;
            listBox1.ForeColor = this.ForeColor;
            label1.Visible = false;

            Size screenSize = Screen.PrimaryScreen.WorkingArea.Size;
            Location = new Point(screenSize.Width / 2 - Width / 2, screenSize.Height / 2 - Height / 2);
            DirectoryInfo dirInfo = new DirectoryInfo(mydoc);
            if (!Directory.Exists(patha))
            {
                try
                {
                    dirInfo.CreateSubdirectory(pad);
                }
                catch
                {
                    patha = "";
                }

            }


            ///this.listBox1.ItemHeight = 100;
            DirectoryInfo dirInfo1 = new DirectoryInfo(patha);
            Addirictory(patha);


        }
        ///фунция rtf_def выдает текст формтирования ртф файла из файла в ричтекстбох
        public void rtf_def(string filePath, string pass1, string pass2, string metod, int pass_interation, string initial_vector, int keySize)
        {
            string stroka = File.ReadAllText(filePath + ".rtf");
            string load = Program.Decrypt(stroka, pass1, pass2, metod, pass_interation, initial_vector, keySize);
            using (StreamWriter writer = File.CreateText(filePath + ".rtf"))
            {
                writer.WriteLine(load);
                writer.Close();

            }

        }
        ///фунция rtf_plan кодирует текст
        public void rtf_plan(string filePath, string pass1, string pass2, string metod, int pass_interation, string initial_vector, int keySize)
        {
            string stroka = File.ReadAllText(filePath + ".rtf");
            string FinalValue = Program.Encrypt(stroka, pass1, pass2, metod, pass_interation, initial_vector, keySize);



            using (StreamWriter writer = File.CreateText(filePath + ".rtf"))
            {
                writer.WriteLine(FinalValue);
                writer.Close();

            }
        }
        /// функция Addirictory проходится по названиям папок
        public void Addirictory(string patha)
        {
            try
            {

                string[] subfolders = Directory.GetDirectories(patha);


                foreach (string subfolder in subfolders)
                {

                    string folder = new DirectoryInfo(subfolder).Name;
                    listBox1.Items.Add(folder);

                }
            }
            catch (Exception ex)
            {
                MessageBox.Show("Ошибка при чтении папки: " + ex.Message);
            }
        }

        private void timer1_Tick(object sender, EventArgs e)
        {


            if (Program.Perem.filesave == true)
            {
                listBox1.Items.Clear();
                Addirictory(patha);
                Program.Perem.filesave = false;
            }
            
            if (Program.pass_conf.pass== true)
            {
                label1.Visible = false;
                string listbox = listBox1.Items[listBox1.SelectedIndex] as string;
                string filePath = System.IO.Path.Combine(patha, listbox);
                filePath = System.IO.Path.Combine(filePath, listbox);
                StreamReader cfg = new StreamReader(filePath + ".cfg");
                string password = cfg.ReadLine();

                string date = cfg.ReadLine();
                cfg.Close();
                defusing_note(filePath, listbox, date);
                
            }
            Console.WriteLine(Program.pass_conf.pass.ToString());

        }
        public void defusing_note(string filePath,string listbox,string date)
        {
            rtf_def(filePath, Program.pass1, Program.pass2, Program.metod, Program.pass_interation, Program.initial_vector, Program.keySize);

            textBox2.Text = listbox;
            richTextBox1.LoadFile(filePath + ".rtf");
            richTextBox1.BackColor = this.BackColor;
            textBox1.BackColor = this.BackColor;
            richTextBox1.Visible = true;
            textBox2.Visible = true;
            button1.BackColor = this.BackColor;
            button1.Visible = true;
            richTextBox1.ForeColor = this.ForeColor;
            textBox1.ForeColor = this.ForeColor;
            ///note.richTextBox1.Text = FinalValue;
            button2.BackColor = this.BackColor;
            button2.Visible = true;
            richTextBox1.SaveFile(filePath + ".rtf", RichTextBoxStreamType.RichText);
            rtf_plan(filePath, Program.pass1, Program.pass2, Program.metod, Program.pass_interation, Program.initial_vector, Program.keySize);

            if (date != "")
            {
                if (Date(patha, listbox, okonch) != null)
                {
                    label1.Text = "Осталось: " + Date(patha, listbox, okonch);
                    label1.Visible = true;
                }
            }
            Program.pass_conf.pass = false;



        }

        public string Date(string patha, string listbox, string[] okonch)
        {

            string date = "";
            string hours = "";
            string minutes = "";
            string exit = "";
            string folder = "";

            try
            {
                folder = System.IO.Path.Combine(patha, new DirectoryInfo(listbox).Name);
                folder = System.IO.Path.Combine(folder, new DirectoryInfo(listbox).Name);
                if (File.Exists(folder + ".cfg"))
                {

                    StreamReader data = new StreamReader(folder + ".cfg");
                    data.ReadLine();
                    date = data.ReadLine();
                    hours = data.ReadLine();
                    minutes = data.ReadLine();
                    data.Close();
                    
                    date = date + " " + hours + ":" + minutes;
                    var Pasedate = DateTime.Parse(date);
                    exit = (Pasedate - DateTime.Now).Days.ToString();

                }
                else
                {
                    exit = folder;
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message + "\n" + folder);
            }
            int exit_c = int.Parse(exit);
            if (exit_c > 15)
            {
                exit_c = exit_c % 10;
            }
            else if (exit_c < 15)
            {
                exit_c = int.Parse(exit);
            }
            exit = exit + " " + okonch[exit_c];


            return exit;
        }



        private void toolStripButton1_Click(object sender, EventArgs e)
        {

            Form2 note = new Form2(patha, mydoc, pad);
            note.BackColor = this.BackColor;
            note.richTextBox1.BackColor = note.BackColor;
            ///note.textBox1.BackColor = note.BackColor;
            note.Visible = true;
            note.richTextBox1.ForeColor = this.ForeColor;
            note.textBox1.ForeColor = this.ForeColor;
            note.Text = "Новая заметка";


        }

        private void темнаяToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.BackColor = Color.DimGray;
            this.ForeColor = Color.White;

            listBox1.BackColor = this.BackColor;
            listBox1.ForeColor = this.ForeColor;
            richTextBox1.BackColor = this.BackColor;
            textBox1.BackColor = this.BackColor;

            button1.BackColor = this.BackColor;
            richTextBox1.ForeColor = this.ForeColor;
            textBox1.ForeColor = this.ForeColor;

        }

        private void белаяToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.BackColor = Color.WhiteSmoke;
            this.ForeColor = Color.Black;

            listBox1.BackColor = this.BackColor;
            listBox1.ForeColor = this.ForeColor;
            listBox1.BackColor = this.BackColor;
            listBox1.ForeColor = this.ForeColor;
            richTextBox1.BackColor = this.BackColor;
            textBox1.BackColor = this.BackColor;

            button1.BackColor = this.BackColor;
            richTextBox1.ForeColor = this.ForeColor;
            textBox1.ForeColor = this.ForeColor;
        }

        private void бисквитToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.BackColor = Color.Beige;
            this.ForeColor = Color.Black;

            listBox1.BackColor = this.BackColor;
            listBox1.ForeColor = this.ForeColor;
            richTextBox1.BackColor = this.BackColor;
            textBox1.BackColor = this.BackColor;

            button1.BackColor = this.BackColor;
            richTextBox1.ForeColor = this.ForeColor;
            textBox1.ForeColor = this.ForeColor;

        }





        private void textBox1_DoubleClick(object sender, EventArgs e)
        {

        }

        private void textBox1_MouseClick(object sender, MouseEventArgs e)
        {

        }

        private void listBox1_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            label1.Visible = false;
            string listbox = listBox1.Items[listBox1.SelectedIndex] as string;
            string filePath = System.IO.Path.Combine(patha, listbox);
            filePath = System.IO.Path.Combine(filePath, listbox);
            StreamReader cfg = new StreamReader(filePath+".cfg");
            string password = cfg.ReadLine();
            
            string date = cfg.ReadLine();
            string hours = cfg.ReadLine();
            string minutes = cfg.ReadLine();
            cfg.Close();
            
            if (password != "" )
            {
                try
                {
                    Form passcheck = new passcheck(password);
                    passcheck.Show();
                   
                }
                catch (Exception ex)
                {
                    MessageBox.Show("Error opening file: " + ex.Message + "\n" + filePath);
                }
            }
            else if(password == "")
            {
                textBox2.Text = listbox;
                richTextBox1.LoadFile(filePath + ".rtf");
                richTextBox1.BackColor = this.BackColor;
                textBox1.BackColor = this.BackColor;
                richTextBox1.Visible = true;
                textBox2.Visible = true;
                button1.BackColor = this.BackColor;
                button1.Visible = true;
                richTextBox1.ForeColor = this.ForeColor;
                textBox1.ForeColor = this.ForeColor;
                ///note.richTextBox1.Text = FinalValue;
                button2.BackColor = this.BackColor;
                button2.Visible = true;
                if (date != "")
                {
                    if (Date(patha, listbox, okonch) != null)
                    {
                        label1.Text = "Осталось: " + Date(patha, listbox, okonch);
                        label1.Visible = true;
                    }
                }
            }

           
        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {
            if (textBox1.Text == "")
            {
                listBox1.Items.Clear();
                Addirictory(patha);
            }

            string searchText = textBox1.Text.ToLower();
            var items = listBox1.Items;

            List<string> matchedItems = new List<string>();
            foreach (string item in items)
            {
                if (item.ToLower().Contains(searchText))
                {
                    matchedItems.Add(item);
                }
            }

            listBox1.Items.Clear();
            listBox1.Items.AddRange(matchedItems.ToArray());

        }

        private void button1_Click(object sender, EventArgs e)
        {
            Form2 note = new Form2(patha, mydoc, pad);
            note.BackColor = this.BackColor;
            note.richTextBox1.BackColor = note.BackColor;
            ///note.textBox1.BackColor = note.BackColor;
            note.richTextBox1.ForeColor = this.ForeColor;
            note.textBox1.ForeColor = this.ForeColor;
            note.textBox1.Text = textBox2.Text;

            string filePath = System.IO.Path.Combine(patha, textBox2.Text);
            filePath = System.IO.Path.Combine(filePath, textBox2.Text);
            StreamReader cfg = new StreamReader(filePath + ".cfg");
            string password = cfg.ReadLine();
            cfg.Close();
            if (password != "")
            {
                rtf_def(filePath, Program.pass1, Program.pass2, Program.metod, Program.pass_interation, Program.initial_vector, Program.keySize);
                note.richTextBox1.LoadFile(filePath + ".rtf");
                note.Text = textBox2.Text;
                note.Visible = true;
                rtf_plan(filePath, Program.pass1, Program.pass2, Program.metod, Program.pass_interation, Program.initial_vector, Program.keySize);
            }
            else
            {
                note.richTextBox1.LoadFile(filePath + ".rtf");
                note.Text = textBox2.Text;
                note.Visible = true;
            }
            

        }

        private void button2_Click(object sender, EventArgs e)
        {
            string tex = textBox2.Text;
            string newpath = System.IO.Path.Combine(patha, tex) + tex + ".txt";
            DialogResult result = MessageBox.Show(
        "Вы уверенны что хотите удалить эту заметку?",
        "Предупреждение",
        MessageBoxButtons.YesNo,
        MessageBoxIcon.Warning,
        MessageBoxDefaultButton.Button1,
        MessageBoxOptions.DefaultDesktopOnly);

            if (result == DialogResult.Yes)
                try
                {
                    Directory.Delete(System.IO.Path.Combine(patha, tex), true);


                    richTextBox1.Visible = false;
                    textBox2.Visible = false;
                    button1.Visible = false;
                    button2.Visible = false;
                    label1.Visible = false;
                    listBox1.Items.Clear();
                    Addirictory(patha);
                    this.Focus();

                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message);
                }

            this.TopMost = true;



        }

        private void listBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            this.listBox1.Invalidate();
        }


        void listBox1_DrawItem(object sender, System.Windows.Forms.DrawItemEventArgs e)
        {
            int index = e.Index;
            Graphics g = e.Graphics;
            foreach (int selectedIndex in this.listBox1.SelectedIndices)
            {
                if (index == selectedIndex)
                {
                    // Draw the new background colour
                    e.DrawBackground();
                    g.FillRectangle(new SolidBrush(Color.DarkSalmon), e.Bounds);
                }
            }

            // Get the item details
            Font font = listBox1.Font;
            Color colour = listBox1.ForeColor;
            string text = listBox1.Items[index].ToString();

            // Print the text
            g.DrawString(text, font, new SolidBrush(Color.Black), (float)e.Bounds.X, (float)e.Bounds.Y);
            e.DrawFocusRectangle();
        }

        private void textBox1_KeyUp(object sender, KeyEventArgs e)
        {

        }
    }
}
