﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using static System.Windows.Forms.VisualStyles.VisualStyleElement;
using System.Security.Cryptography;
using System.IO;
using static System.Net.Mime.MediaTypeNames;
using System.Diagnostics;
using static System.Windows.Forms.VisualStyles.VisualStyleElement.Window;

namespace AllNotes
{
    public partial class Form2 : Form
    {
        string patha, mydoc, pad, tex;
        FontStyle[] font_style = { FontStyle.Bold, FontStyle.Italic, FontStyle.Underline };

        public Form2(string patha, string mydoc, string pad)
        {
            InitializeComponent();
            this.patha = patha;
            this.mydoc = mydoc;
            this.pad = pad;
            Size screenSize = Screen.PrimaryScreen.WorkingArea.Size;
            Location = new Point(screenSize.Width / 2 - Width / 2, screenSize.Height / 2 - Height / 2);




        }


        string pass1 = "allsmirno";
        string pass2 = "qq0";
        string metod = "SHA1";
        int pass_interation = 16;
        string initial_vector = "Qsd23Mkjk7898*hj";
        int keySize = 256;

        private void textBox1_TextChanged(object sender, EventArgs e)
        {

        }

        private void Form2_FormClosing(object sender, FormClosingEventArgs e)
        {

        }

        private void Form2_Load(object sender, EventArgs e)
        {
            foreach (FontFamily font in System.Drawing.FontFamily.Families)
            {
                //fonts.Add(font.Name);
                toolStripComboBox1.Items.Add(font.Name);
            }
            toolStripComboBox1.Text = richTextBox1.Font.Name;
            toolStripComboBox2.Text = richTextBox1.Font.Height.ToString();
            int[] Font_height = new int[40];
            for (int i = 1; i < 40; i++)
            {
                Font_height[i] = i;
                toolStripComboBox2.Items.Add(i);

            }

        }

        private void toolStripComboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {

            richTextBox1.SelectionFont = new Font(toolStripComboBox1.Text, richTextBox1.Font.Height);

        }

        private void toolStripComboBox2_TextChanged(object sender, EventArgs e)
        {
            try
            {
                if (int.Parse(toolStripComboBox2.Text) > 0)
                {
                    richTextBox1.SelectionFont = new Font(toolStripComboBox1.Text, int.Parse(toolStripComboBox2.Text));
                }

            }
            catch
            {
                toolStripComboBox2.Text = 14.ToString();
            }
        }

        private void toolStripButton2_Click(object sender, EventArgs e)
        {
            button1.PerformClick();
        }

        private void toolStripButton3_Click(object sender, EventArgs e)
        {

            int tag = Convert.ToInt32(toolStripButton3.Tag);

            Font current = richTextBox1.SelectionFont;
            if (toolStripButton3.Checked)
                richTextBox1.SelectionFont = new Font(current.FontFamily, current.Size, font_style[tag] | current.Style);
            else
                richTextBox1.SelectionFont = new Font(current.FontFamily, current.Size, font_style[tag] ^ current.Style);



            Console.WriteLine(tag.ToString());
        }


        private void toolStripButton5_Click(object sender, EventArgs e)
        {
            int tag = Convert.ToInt32(toolStripButton4.Tag);

            Font current = richTextBox1.SelectionFont;

            if (toolStripButton4.Checked)
                richTextBox1.SelectionFont = new Font(current.FontFamily, current.Size, font_style[tag] | current.Style);
            else
                richTextBox1.SelectionFont = new Font(current.FontFamily, current.Size, font_style[tag] ^ current.Style);

            Console.WriteLine(tag.ToString());
        }

        private void toolStripButton4_Click(object sender, EventArgs e)
        {
            int tag = Convert.ToInt32(toolStripButton5.Tag);

            Font current = richTextBox1.SelectionFont;

            if (toolStripButton5.Checked)
                richTextBox1.SelectionFont = new Font(current.FontFamily, current.Size, font_style[tag] | current.Style);
            else
                richTextBox1.SelectionFont = new Font(current.FontFamily, current.Size, font_style[tag] ^ current.Style);

            Console.WriteLine(tag.ToString());
        }

        private void textBox1_KeyUp(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter) richTextBox1.Focus();
        }

        private void textBox1_Enter(object sender, EventArgs e)
        {

        }

        private void toolStripButton1_Click(object sender, EventArgs e)
        {
            tex = textBox1.Text;
            Form3 date = new Form3(patha, mydoc, pad, tex);
            date.BackColor = this.BackColor;
            date.Visible = true;
            date.ForeColor = this.ForeColor;


        }
        

        private void button1_Click(object sender, EventArgs e)
        {

            DirectoryInfo files_a = new DirectoryInfo(System.IO.Path.Combine(System.Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments), "AllNotes"));
            try
            {
                files_a.CreateSubdirectory(textBox1.Text);
            }
            catch
            {
                if (textBox1.Text == "")
                {
                    textBox1.Text = "Новая метка";
                }
            }
            tex = textBox1.Text;
            string path = System.IO.Path.Combine(patha, tex);
            string file = System.IO.Path.Combine(path, tex);
            var create =File.Create(file + ".cfg");
            
            create.Close();
            StreamReader cfg = new StreamReader(file + ".cfg");
            string password = cfg.ReadLine();
            cfg.Close();

           
            richTextBox1.SaveFile(file + ".rtf", RichTextBoxStreamType.RichText);
            if(String.IsNullOrEmpty(password) )
            {
                var result = MessageBox.Show("Хотите ли вы установить пароль для вашей заметки?", "Пароль",
                                 MessageBoxButtons.YesNo,
                                 MessageBoxIcon.Question);


                if (result == DialogResult.Yes)
                {
                    string stroka = File.ReadAllText(file + ".rtf");
                    string confrim = "Придумайте пароль: ";
                    Пароль passblank = new Пароль(confrim, stroka, file);
                    passblank.Show();
                    passblank.BackColor = this.BackColor;
                    passblank.ForeColor = this.ForeColor;
                }
                else
                {
                    using (StreamWriter writer = File.CreateText(file + ".cfg"))
                    {
                        writer.WriteLine();

                        if (Program.date != "" && Program.time_h != "" && Program.time_m != "")
                        {
                            writer.WriteLine(Program.date);
                            writer.WriteLine(Program.time_h);
                            writer.WriteLine(Program.time_m);
                            
                        }
                        writer.Close();
                    }
                }
            }
            else 
            {
                var result = MessageBox.Show("Хотите установить новый пароль?", "Пароль",
                                 MessageBoxButtons.YesNo,
                                 MessageBoxIcon.Question);


                if (result == DialogResult.Yes)
                {
                    string stroka = File.ReadAllText(file + ".rtf");
                    string confrim = "Придумайте пароль: ";
                    Пароль passblank = new Пароль(confrim, stroka, file);
                    passblank.Show();
                    passblank.BackColor = this.BackColor;
                    passblank.ForeColor = this.ForeColor;
                }
                else
                {
                    StreamReader cfg1 = new StreamReader(file + ".cfg");
                    string password1 = cfg1.ReadLine();

                    string date = cfg1.ReadLine();
                    cfg1.Close();
                    using (StreamWriter writer = File.CreateText(file + ".cfg"))
                    {
                        writer.WriteLine(cfg1);

                        if (Program.date != "" && Program.time_h != "" && Program.time_m != "")
                        {
                            writer.WriteLine(Program.date);
                            writer.WriteLine(Program.time_h);
                            writer.WriteLine(Program.time_m);
                            
                        }
                        writer.Close();

                    }
                }

            }
            
            







                Program.Perem.filesave = true;

                if (Program.easter_egg.ContainsKey(textBox1.Text))
                {
                    Process.Start(Program.easter_egg[textBox1.Text]);
                }


            


        }
    }
}
